#include <stdio.h>
#include <process.h>
#include <dir.h>
#include <io.h>

char cd[80] = "Squeeze DOS 5.0 --- Ray Van Tassle, Sept, 1991";
FILE *o;
int stat;
long int t_siz1 = 0;	/* original size */
long int t_siz2 = 0;	/* expanded size */
long int t_siz3 = 0;	/* packed size */
FILE *lstout;

main(int argc, char **argv)
{
   struct ffblk fb;
   char name[MAXFILE];
   char ext[MAXEXT];
   int done;

   puts(cd);
   if (argc == 1 || !(*argv[1] == 'F' || *argv[1] == 'S')) {
	puts("Usage:  sqz_dos F/S");
	puts("   Squeeze down the executable files from '\\DOS50\\' to '\\TEMP\\'");
	puts("   But not the ones that should not be shrunk!");
	puts("\t 'F' = print info to 'a_sqz.out'");
	puts("\t 'S' = type info to screen\n");
	return(255);
	}
	lstout = stderr;
   if (*argv[1] == 'F')
   lstout = fopen("a_sqz.out", "w");
   getcwd(cd, 80);
   stat = chdir("\\temp");
   if (stat != 0) {
      puts("Can't set to \\TEMP");
      chdir(cd);
      exit(255);
   }

   freopen("nul", "w", stdout);
   fprintf(lstout, "Sizes--        Original   Unpacked   Re-packed\n");
   done = findfirst("\\dos50\\*.exe", &fb, 0);	/* Get original file size */
   while (!done) {
      fnsplit(fb.ff_name, 0, 0, name, ext);
      do_exe(name, &ext[1]);
      done = findnext(&fb);
   }

   fprintf(lstout, "-------------  --------   --------   --------\n");
   fprintf(lstout, "%-13s: %8ld   %8ld   %8ld\n",
	"Total (EXE's)", t_siz1, t_siz2, t_siz3);
   fprintf(lstout, "Re-packed is %5.1f%% of un-EXEPACK'ed size.\n",
	100.*t_siz3/t_siz2);
   fprintf(lstout, "Re-packed is %5.1f%% of original size.\n",
	100.*t_siz3/t_siz1);

   fprintf(lstout, "\n");
   done = findfirst("\\dos50\\*.com", &fb, 0);	/* Get original file size */
   while (!done) {
      fnsplit(fb.ff_name, 0, 0, name, ext);
      do_exe(name, &ext[1]);
      done = findnext(&fb);
   }

   fprintf(lstout, "-------------  --------   --------   --------\n");
   fprintf(lstout, "%-13s: %8ld   %8ld   %8ld\n",
	"Grand Total", t_siz1, t_siz2, t_siz3);
   fprintf(lstout, "Re-packed is %5.1f%% of un-EXEPACK'ed size.\n",
	100.*t_siz3/t_siz2);
   fprintf(lstout, "Re-packed is %5.1f%% of original size.\n",
	100.*t_siz3/t_siz1);

   chdir(cd);
   return(0);
}

do_exe(char *name, char *ext)
{
   char fn1[80];
   char fn2[80];
   char bfr[80];
   int i;
   long int siz1;	/* original size */
   long int siz2;	/* expanded size */
   long int siz3;	/* packed size */
   struct ffblk fb;

   strupr(name);
   strupr(ext);
   sprintf(bfr, "copy \\dos50\\%s.%s >nul", name, ext);
   system(bfr);
   sprintf(fn1, "%s.%s", name, ext);
   sprintf(fn2, "%s.%s", name, "old");

   i = findfirst(fn1, &fb, 0);	/* Get original file size */
   if (i == 0)
      siz1 = fb.ff_fsize;
   siz2 = siz3 = siz1;
   stat = 0;


   if (strcmp(ext, "EXE") == 0) {
      /* Try to un_EXEPACK it */
      stat = spawnlp(P_WAIT, "upackex2", "x", fn1, NULL);
      if (stat != 0) {
	 stat = spawnlp(P_WAIT, "upackexe", "x", fn1, NULL);
      }
      if (stat == 0)
	 spawnlp(P_WAIT, "touch", "x", fn1, "-l", fn2, NULL);
      unlink(fn2);
   }

   if (stat == 0 && strcmp(fn1, "COMMAND.COM") != 0) {
      /* It did unpack!! */
      i = findfirst(fn1, &fb, 0);	/* Get expanded file size */
      if (i == 0)
	 siz2 = fb.ff_fsize;
      spawnlp(P_WAIT, "pklite", "x", fn1, NULL);
   }
   i = findfirst(fn1, &fb, 0);	/* Get original file size */
   if (i == 0)
      siz3 = fb.ff_fsize;
   fprintf(lstout, "%-13s: %8ld   %8ld   %8ld\n",
	fn1, siz1, siz2, siz3);
   t_siz1 += siz1;
   t_siz2 += siz2;
   t_siz3 += siz3;
}
